#include <iostream>
#include <fstream>
#include <cmath>
using namespace std;

//==============================================
//	Définition de la fonction
//==============================================
double f (double x) { return (x*x +2.*x-2.);}
//==============================================

//==============================================
//	Compte la taille du vecteur d un fichier
//==============================================
int Nbl(const char *fichier)
{ifstream fic(fichier);
double c;
int compte=0;
while ( (fic >>c).good() ){			//lecture de chaque ligne
compte++;
}
//cout << "nombre de points de discretisation : " << compte << endl;
fic.clear();
return compte;}
//==============================================

//==============================================
//	Calcul et ecrit F
//==============================================
void fonct(int N ,double f(double x))
{ofstream ff("second.dat");
ifstream fic("pas.dat");
N=N-1; //pour avoir le nombre d intervalle et non le nombre de point de discretisation
// initialise le pas dans le tableau c de N lignes
double * c= new double[N];
for ( int i=0; i<N ;i++){fic >> c[i]; }

// s occupe du cas particulier au bord, ou l on a un demi chapeau
ff << c[0] << "\t" << ((c[1]-c[0])/2.)*(f(c[0])+f(c[1])) <<endl;

//on approche f par la methode des trapezes.
for ( int i=1; i<N-1 ;i++)
{ ff<< c[i] <<"\t"<<((c[i]-c[i-1])/2.)*(f(c[i])) + ((c[i+1]-c[i])/2.)*(f(c[i]))<<endl; }

//l autre cas particulier au bord
ff << c[N-1] << "\t" << ((c[N-1]-c[N-2])/2.)*(f(c[N-2])+f(c[N-1])) <<endl;


fic.clear();
delete [] c;

//le fichier contient en premier le pas, puis separer par tab le second membre de taille N.
cout << "fichier ecrit : \"second.dat\""<<endl;
}
//====================================================


//====================================================
//	Lance le tout
//====================================================
int main () {
int N = Nbl("pas.dat");
fonct ( N,f);
cout << "Taille de second.dat :"<< Nbl("second.dat")/2<<endl;
}
//====================================================
