#include <iostream>
#include <cmath>
#include <fstream>
#include <vector>

using namespace std;


class Mesh1D{ 
public:
vector <double> Tab;
int N;
public:
Mesh1D(int Max);
void Decoupage();
};

//======================================
Mesh1D::Mesh1D(int Max)
{ Tab =vector<double> (Max);
N=0;
}
//======================================


//============================================

void Mesh1D::Decoupage()
{
//declaration des variables utilisees
double l0;				//debut de l intervalle a discretise
double l1;				//fin de l intervalle a discretise
double h;				//le pas
double L;				//longueur de l intervalle
char * cho = new char [6];		//variable qui stock la réponse a variable ou constant
double pi;				//pi=3.14
double x;				//variable de boule
pi=2*asin(1.0);
//Pose les questions
cout << "Donner l0:"<<endl;
cin >> l0;
cout <<"Donner l1:"<<endl;
cin >> l1;
cout << "Pas variable ou pas constant ?(choix: var ou const )"<<endl;
cin >> cho;
h=1./(double (N) );
L= sqrt( pow((l1 - l0),2));		//calcul la longueur de l intervalle
ofstream ff("pas.dat");
double eps;
eps=3./4.;				//definition de eps pour le pas variable
if (strcmp (cho , "var")==0 )
	{for (int i=0; i<N+1 ; i++)
	{ x = l0 + L*sin(eps*pi/2.*i*h)/sin(eps*pi/2.);
	//cout<< x <<endl;
	ff<< x <<endl;}
	}
else if (strcmp ( cho , "const" )==0)
	{for (int i=0; i<N+1 ; i++)
	{ x= l0 + (i*h*L);
	//cout<< x <<endl;
	ff<< x << endl;
	}}
else 	{cout << "erreur vous n avez pas tape const ou var"<<endl;
	exit(0);}
cout<< " fichier ecrit : pas.dat "<<endl;
delete [] cho;
}


//============================================


//=====================================
int main (void)
{
int N;
cout << "Donner le nombre d intervalle a discretiser:"<<endl;
cin >> N;
Mesh1D P(N);
P.N=N;
P.Decoupage();
return 0;
}

//=====================================
