#include <fstream>
#include <iostream>

#include "Mesh2d.hpp"

Mesh::Mesh(const char * filename)
  : nt(0),nv(0),area(0.), vertices(0), triangles(0)
{ // read the mesh
	int i,neb,i0,i1,i2,ir;
	ifstream f(filename);
	if(!f) {cerr << "Mesh::Mesh Erreur openning " << filename<<endl;exit(1);}
	cout << " Read On file \"" <<filename<<"\""<<  endl;
	f >> nv >> nt >> neb ;
	cout << " Nb of Vertex " << nv << " " << " Nb of Triangles " << nt << endl;
	assert(f.good() && nt && nv) ;
	triangles = new Triangle [nt];
	vertices = new Vertex[nv];
	area=0;
	assert(triangles && vertices);
	for (i=0;i<nv;i++)    
		f >> vertices[i],assert(f.good());
	for (i=0;i<nt;i++) { 
		f >> i0 >> i1 >> i2 >> ir;
		assert(f.good() && i0>0 && i0<=nv && i1>0 && i1<=nv && i2>0 && i2<=nv);
		triangles[i].set(vertices,i0-1,i1-1,i2-1,ir); 
		area += triangles[i].area;}
	cout << " End of read: area = " << area <<endl;  
}
