import java.awt.*;
import java.io.*;
import java.awt.event.*;

public class entreur extends Dialog implements MouseListener
{
    String dfname = "projet.txt", 	gridname ;
    int offset = 80, hmax =380 , vmax =180, downoffset = 40 + offset;
    Button loadtriau, runjob,bouton;
    boolean mesh=false;
    TextField textfield1,textfield2,textfield3,textfield4,textfield5,textfield6;
    Label  sigmax,sigmay,q,r,K,T;
    String sigmaxval="0.2",sigmayval="0.1",qval="-0.25",rval="0.02",Kval="100",Tval="0.25";

        
public  entreur(Frame parent) {
        super(parent, "Programme pour rentrer les constantes", false);
        this.setSize(hmax+2*offset, vmax+4*offset);
}

public class  getfilename extends Frame{ 
  FileDialog fd;
  public String fname;
    public getfilename() { }
    public String getthename(){   
        fd = new FileDialog(this, "Choix de maillage",FileDialog.LOAD);
        fd.setVisible(true);
        fname = fd.getFile();
        return fname;
	}
}

public void myinterface(){
        this.setLayout(new FlowLayout());        
        loadtriau = new Button("charger Mesh");this.add(loadtriau);
        runjob = new Button("Executer");  	this.add(runjob);
	bouton = new Button("Exit");		this.add(bouton);
        sigmax = new Label("sigma x =");
        textfield1 = new TextField(sigmaxval,10) ;
        this.add(sigmax); 				
        this.add(textfield1);

        sigmay = new Label("sigma y =");
        textfield2 = new TextField(sigmayval,10) ;
        this.add(sigmay); 				
        this.add(textfield2);

        q = new Label("q =");
        textfield3 = new TextField(qval,10) ;
        this.add(q); 				
        this.add(textfield3);

        r = new Label("r =");
        textfield4 = new TextField(rval,10) ;
        this.add(r); 				
        this.add(textfield4);

        K = new Label("K =");
        textfield5 = new TextField(Kval,10) ;
        this.add(K); 				
        this.add(textfield5);

        T = new Label("T =");
        textfield6 = new TextField(Tval,10) ;
        this.add(T); 				
        this.add(textfield6);

        this.pack();        
        Graphics g = this.getGraphics();    
        loadtriau.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){  
	            getfilename ff = new getfilename();
	            gridname = ff.getthename();
	            mesh = true;
            }
        });  
	    runjob.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){ 
	   	    savemyparam();
		    String line;
		    Runtime rt = Runtime.getRuntime();
                    try{ 
		    System.out.println("on lance la partie C++");
            Process  ax = rt.exec("./sfemGC2");
		    InputStream ao = ax.getInputStream() ;
		    BufferedReader br = new BufferedReader(new InputStreamReader(ao));
		      while (( line= br.readLine()) != null) {
		        System.out.println(line);
		      }
		    } 
                        catch (IOException Ex){ 
				System.out.println("catch execption exec ");
                                System.out.println(Ex.getMessage());
				System.exit(1);             
			    } 
				System.out.println(" Operation reussie  ");
            		System.exit(0);             
              }
        }); 

 	bouton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e){
        dispose();
	System.exit(2);
      }});  
        this.addMouseListener(this);
        addMouseListener(this);
}

public void savemyparam() 
    {   String sigmaxval = textfield1.getText();
        String sigmayval = textfield2.getText();
        String qval = textfield3.getText();
        String rval = textfield4.getText();
        String Kval = textfield5.getText();
        String Tval = textfield6.getText();
        try{
            FileOutputStream filename= 
            new FileOutputStream(dfname);
            PrintStream ffile = new PrintStream(filename);
            ffile.println(sigmaxval);
            ffile.println(sigmayval);
            ffile.println(qval);
            ffile.println(rval);
            ffile.println(Kval);
            ffile.println(Tval);

            if(mesh) ffile.println(gridname);
         }
        catch (IOException Ex)
        {
            System.out.println(Ex.getMessage());
        }
    }   
    
public void paint( Graphics g ) {;}           
public void mousePressed(MouseEvent e) {;}
public void mouseReleased(MouseEvent e){;}          
public void mouseEntered(MouseEvent e) {;}
public void mouseClicked(MouseEvent e) {;}
public void mouseExited(MouseEvent e)  {;}

public static void main(String[] args){
        Frame f = new Frame("win");
        entreur b = new entreur(f);
        b.myinterface();
        b.setSize(565,110);
        b.setVisible(true);
        
    }
}
